diff --git a/lisp/Makefile.am b/lisp/Makefile.am
index af26c97..8fc4c97 100644
--- a/lisp/Makefile.am
+++ b/lisp/Makefile.am
@@ -33,6 +33,7 @@ dist_lisp_LISP = 				\
 	bbdb-mhe.el				\
 	bbdb-migrate.el				\
 	bbdb-mua.el				\
+	bbdb-mu4e.el				\
 	bbdb-pgp.el				\
 	bbdb-print.el				\
 	bbdb-rmail.el				\
diff --git a/lisp/bbdb-mu4e.el b/lisp/bbdb-mu4e.el
new file mode 100644
index 0000000..08cc4a6
--- /dev/null
+++ b/lisp/bbdb-mu4e.el
@@ -0,0 +1,41 @@
+;;; bbdb-mu4e.el --- BBDB interface to mu4e
+
+;; Copyright (C) 1991, 1992 Jamie Zawinski <jwz@netscape.com>.
+;; Copyright (C) 2010-2015 Roland Winkler <winkler@gnu.org>
+
+;; This file is part of the Insidious Big Brother Database (aka BBDB),
+
+;; BBDB is free software: you can redistribute it and/or modify
+;; it under the terms of the GNU General Public License as published by
+;; the Free Software Foundation, either version 3 of the License, or
+;; (at your option) any later version.
+
+;; BBDB is distributed in the hope that it will be useful,
+;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; GNU General Public License for more details.
+
+;; You should have received a copy of the GNU General Public License
+;; along with BBDB.  If not, see <http://www.gnu.org/licenses/>.
+
+;;; Commentary:
+;;; This file contains the BBDB interface to mu4e.
+;;; See the BBDB info manual for documentation.
+
+(require 'bbdb)
+(require 'bbdb-com)
+(require 'bbdb-mua)
+
+;;;###autoload
+(defun bbdb-insinuate-mu4e ()
+  "Hook BBDB into mu4e.
+Do not call this in your init file.  Use `bbdb-initialize'."
+  ;; Do we need keybindings for more commands?  Suggestions welcome.
+  (define-key mu4e-view-mode-map ":" 'bbdb-mua-display-sender)
+  (define-key mu4e-view-mode-map ";" 'bbdb-mua-edit-field-sender)
+  ;; Tackle headers later
+  ;; (define-key mu4e-headers-mode-map ":" 'bbdb-mua-display-sender)
+  ;; (define-key mu4e-headers-mode-map ";" 'bbdb-mua-edit-field-sender)
+  )
+
+(provide 'bbdb-mu4e)
diff --git a/lisp/bbdb-mua.el b/lisp/bbdb-mua.el
index 4b6f116..364c90a 100644
--- a/lisp/bbdb-mua.el
+++ b/lisp/bbdb-mua.el
@@ -63,7 +63,9 @@
     (rmail rmail-mode rmail-summary-mode)
     (mh mhe-mode mhe-summary-mode mh-folder-mode)
     (message message-mode)
-    (mail mail-mode))
+    (mail mail-mode)
+    ;; Tackle mu4e-headers-mode later
+    (mu4e mu4e-view-mode))
   "Alist of MUA modes supported by BBDB.
 Each element is of the form (MUA MODE MODE ...), where MODEs are used by MUA.")
 
@@ -108,6 +110,7 @@ MIME encoded headers are decoded.  Return nil if HEADER does not exist."
                     ((eq mua 'vm) (bbdb/vm-header header))
                     ((eq mua 'rmail) (bbdb/rmail-header header))
                     ((eq mua 'mh) (bbdb/mh-header header))
+                    ((eq mua 'mu4e) (message-field-value header))
                     ((memq mua '(message mail)) (message-field-value header))
                     (t (error "BBDB/%s: header function undefined" mua)))))
     (if val (mail-decode-encoded-word-string val))))
@@ -601,6 +604,13 @@ If SORT is non-nil, sort records according to `bbdb-record-lessp'."
         (set-buffer rmail-buffer)
         (bbdb-update-records (bbdb-get-address-components header-class)
                              update-p sort))
+
+       ;; mu4e
+       ((eq mua 'mu4e)
+        (set-buffer mu4e~view-buffer-name)
+        (bbdb-update-records (bbdb-get-address-components header-class)
+                             update-p sort))
+
        ;; Message and Mail
        ((memq mua '(message mail))
         (bbdb-update-records (bbdb-get-address-components header-class)
@@ -618,7 +628,7 @@ If SORT is non-nil, sort records according to `bbdb-record-lessp'."
             (save-current-buffer
               (gnus-summary-select-article) ; sets buffer `gnus-summary-buffer'
               ,@body))
-           ((memq mua '(mail message rmail mh vm))
+           ((memq mua '(mail message rmail mh vm mu4e))
             (cond ((eq mua 'vm) (vm-follow-summary-cursor))
                   ((eq mua 'mh) (mh-show)))
             ;; rmail, mail and message do not require any wrapper
diff --git a/lisp/bbdb.el b/lisp/bbdb.el
index ba7423a..bfb8c88 100644
--- a/lisp/bbdb.el
+++ b/lisp/bbdb.el
@@ -1666,7 +1666,8 @@ See also `bbdb-silent'.")
             (add-hook 'mail-setup-hook 'bbdb-insinuate-mail)))
     (message                    ; the gnus mail user agent
      (add-hook 'message-setup-hook 'bbdb-insinuate-message))
-
+    (mu4e                       ; the mu4e user agent
+     (add-hook 'mu4e-main-mode-hook 'bbdb-insinuate-mu4e))
     (sc                         ; supercite
      (add-hook 'sc-load-hook 'bbdb-insinuate-sc))
     (anniv                      ; anniversaries
@@ -4493,6 +4494,7 @@ List MUAS may include the following symbols to initialize the respective
 mail/news readers, composers, and miscellaneous packages:
   gnus       Gnus mail/news reader.
   mh-e       MH-E mail reader.
+  mu4e       mu4e mail reader.
   rmail      Rmail mail reader.
   vm         VM mail reader.
   mail       Mail (M-x mail).